//+------------------------------------------------------------------+
//|                                                   ShowSeries.mq4 |
//|                                      Copyright  2009, Marketeer |
//|                                                          v.1.0.2 |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Marketeer"
#property link      "http://www.mql4.com"

#property indicator_chart_window

#property indicator_buffers 1
#property indicator_color1 Red

extern string FileName = "process.csv";
extern string Delimiter = ";";
extern datetime StartDate = 0; // 0 - means now
extern int ColumnNo = 0;

double Buffer[];
int SeriesSize;

int GetFileCount()
{
  int count = 0;
  int columns = 0;
  int handle = FileOpen(FileName, FILE_CSV|FILE_READ, Delimiter);
  if(handle > 0)
  {
    while(!FileIsEnding(handle))
    {
      string x = FileReadString(handle);
      if(StringLen(StringTrimLeft(StringTrimRight(x))) == 0) break;
      if(count == 0)
      {
        columns++;
      }
      if(FileIsLineEnding(handle))
      {
        count++;
      }
    }
    FileClose(handle);
  }
  Comment("Column ", ColumnNo, "(", columns, "),", " Lines:", count);
  return(count);
}

int ReadFile(int offset)
{
  int count = 0;
  int column = 0;
  int handle = FileOpen(FileName, FILE_CSV|FILE_READ, Delimiter);
  if(handle > 0)
  {
    while(!FileIsEnding(handle))
    {
      string x;
      x = FileReadString(handle);
      if(StringLen(StringTrimLeft(StringTrimRight(x))) == 0) break; // EOF
      if(column == ColumnNo)
      {
        int pt, comma;
        pt = StringFind(x, ".");
        comma = StringFind(x,",");
        if(pt == -1 && comma != -1) x = StringSubstr(x, 0, comma) + "." + StringSubstr(x, comma + 1);
        Buffer[offset - count] = StrToDouble(x);
        count++;
      }
      if(FileIsLineEnding(handle))
      {
        column = 0;
      }
      else
      {
        column++;
      }
    }
    FileClose(handle);
  }

}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  IndicatorBuffers(1);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, Buffer);
  SetIndexLabel(0, "Show series " + FileName + "(" + ColumnNo + ")");
  
  if(StartDate == 0)
  {
    StartDate = Time[0];
  }
  
  SeriesSize = GetFileCount();
  int Offset = iBarShift(NULL, 0, StartDate);
  Print(TimeToStr(StartDate), " ", Offset);
  SetIndexShift(0, SeriesSize - Offset);
  
  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  static bool bFileRead = false;
  if(!bFileRead)
  {
    ReadFile(SeriesSize);
    bFileRead = true;
  }
  return(0);
}
//+------------------------------------------------------------------+